package server.dao;

import server.AclEntry;
import server.Group;
import server.User;

import javax.persistence.NoResultException;
import java.util.List;

public interface GroupDAO extends GenericDAO<Group, Long> {
	/**
	 * Add a user to this group. <em>This creates a GroupUser object!</em>
	 * @param userID ID of the user to add to this group
	 * @param groupID ID of the group to add the user to
	 * @return id of the GroupUser object
	 */
	Long addToUser(Long userID, Long groupID);

	/**
	 * add a group to a target acl. <em>This creates an AclEntry object!</em>
	 * @param aclID
	 * @param groupID
	 * @return AclEntry object
	 */
	AclEntry addToAcl(Long aclID, Long groupID);

	void removeFromAcl(Long aclID, Long groupID);

	Group findByID(Long id);
	List<Group> findAllByID(Long id);

	/**
	 * @return Group	The personal group of this user.
	 */
	Group findByUser(User user) throws NoResultException;
	
	Group findByName(String name) throws NoResultException;
	
	void removeUserFromGroup(Long userId, Long groupId);
}
