package server.dao;

import server.Relation;
import server.RelationType;
import server.data.ObjectSystemData;

import java.util.List;

public interface RelationDAO extends GenericDAO<Relation, Long> {
	List<Relation> findAllByLeftID(Long leftID);
	
	List<Relation> findAllByLeftOrRightID(Long leftID, Long rightID);
	
	/**
	 * Check whether a relation already exists.
	 */
	Relation findOrCreateRelation(RelationType type, ObjectSystemData left, ObjectSystemData right);
	
	List<Relation> findAllByLeft(ObjectSystemData left);
	List<Relation> findAllByRight(ObjectSystemData right);
	List<Relation> findAllByLeftAndRight(ObjectSystemData left, ObjectSystemData right);
	
	List<Relation> findAllByLeftAndType(ObjectSystemData left, RelationType type);
	List<Relation> findAllByLeftAndRightAndType(ObjectSystemData left, ObjectSystemData right, RelationType type);
	List<Relation> findAllByRightAndType(ObjectSystemData right, RelationType type);
	
	List<Relation> findAllByType(RelationType type);
}
