package server.dao;

import server.RelationType;
import utils.ParamParser;

import javax.persistence.EntityManager;
import javax.persistence.Query;
import java.util.List;

public class RelationTypeDAOHibernate extends
		GenericHibernateDAO<RelationType, Long> implements RelationTypeDAO {

	@Override
	public void delete(Long relationTypeID) {
		EntityManager em = getSession();
		Query q = em.createQuery("select r from RelationType r where id=:id").setParameter("id", relationTypeID);
		RelationType moribundus = (RelationType) q.getSingleResult();
		makeTransient(moribundus);
	}

	@Override
	public RelationType findByName(String name) {
		Query q = getSession().createQuery("select rt from RelationType rt where name=:name");
		q.setParameter("name", name);
		return (RelationType) q.getSingleResult();	
	}

	@Override
	public RelationType get(Long id) {
		return getSession().find(RelationType.class, id);
	}
	
	@Override
	public RelationType get(String id) {
		Long relTypeId = ParamParser.parseLong(id, "error.param.id"); 
		return getSession().find(RelationType.class, relTypeId);
	}

	@SuppressWarnings("unchecked")
	@Override
	public List<RelationType> list() {
		Query q = getSession().createNamedQuery("selectAllRelationTypes");
		return q.getResultList();
	}

}
