package server.lifecycle.state;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import server.data.ObjectSystemData;
import server.lifecycle.BaseLifeCycleState;
import server.lifecycle.IState;

import java.util.List;

/**
 *
 */
public class DemoReviewState extends BaseLifeCycleState implements IState {

    Logger log = LoggerFactory.getLogger(this.getClass());

    @Override
    public List<IState> getExitStates(ObjectSystemData osd) {
        return states;
    }

    @Override
    public Boolean checkEnteringObject(ObjectSystemData osd) {
        // object must be in "authoring" state.
        if(osd.getState() == null){
            return false;
        }
        else if(osd.getState().getName().equals("authoring")){
            return true;
        }
        return false;
    }

    @Override
    public void enter(ObjectSystemData osd) {
        log.debug("osd "+osd.getId()+" entered DemoReviewState.");
    }

    @Override
    public void exit(ObjectSystemData osd, IState nextState) {
        log.debug("osd "+osd.getId()+" left DemoReviewState.");
    }
}